/*
 * Coscine Web API
 *
 * Coscine (short for <b>CO</b>llaborative <b>SC</b>ientific <b>IN</b>tegration <b>E</b>nvironment) is the research data management platform for your research project.
 *
 * The version of the OpenAPI document: 2.0
 * Contact: servicedesk@itc.rwth-aachen.de
 * Generated by: https://github.com/openapitools/openapi-generator.git
 */


using System;
using System.Collections;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.IO;
using System.Runtime.Serialization;
using System.Text;
using System.Text.RegularExpressions;
using Newtonsoft.Json;
using Newtonsoft.Json.Converters;
using Newtonsoft.Json.Linq;
using System.ComponentModel.DataAnnotations;
using OpenAPIDateConverter = Coscine.ApiClient.Core.Client.OpenAPIDateConverter;

namespace Coscine.ApiClient.Core.Model
{
    /// <summary>
    /// Data transfer object (DTO) representing the update of a metadata tree.  Inherits from the base class Coscine.Api.Core.Shared.DataTransferObjects.ParameterObjects.MetadataTreeForManipulationDto.
    /// </summary>
    [DataContract(Name = "MetadataTreeForUpdateDto")]
    public partial class MetadataTreeForUpdateDto : IValidatableObject
    {
        /// <summary>
        /// Initializes a new instance of the <see cref="MetadataTreeForUpdateDto" /> class.
        /// </summary>
        [JsonConstructorAttribute]
        protected MetadataTreeForUpdateDto() { }
        /// <summary>
        /// Initializes a new instance of the <see cref="MetadataTreeForUpdateDto" /> class.
        /// </summary>
        /// <param name="path">Gets or initializes the path of the metadata tree. (required).</param>
        /// <param name="definition">definition (required).</param>
        public MetadataTreeForUpdateDto(string path = default(string), RdfDefinitionForManipulationDto definition = default(RdfDefinitionForManipulationDto))
        {
            // to ensure "path" is required (not null)
            if (path == null)
            {
                throw new ArgumentNullException("path is a required property for MetadataTreeForUpdateDto and cannot be null");
            }
            this.Path = path;
            // to ensure "definition" is required (not null)
            if (definition == null)
            {
                throw new ArgumentNullException("definition is a required property for MetadataTreeForUpdateDto and cannot be null");
            }
            this.Definition = definition;
        }

        /// <summary>
        /// Gets or initializes the path of the metadata tree.
        /// </summary>
        /// <value>Gets or initializes the path of the metadata tree.</value>
        [DataMember(Name = "path", IsRequired = true, EmitDefaultValue = true)]
        public string Path { get; set; }

        /// <summary>
        /// Gets or Sets Definition
        /// </summary>
        [DataMember(Name = "definition", IsRequired = true, EmitDefaultValue = true)]
        public RdfDefinitionForManipulationDto Definition { get; set; }

        /// <summary>
        /// Returns the string presentation of the object
        /// </summary>
        /// <returns>String presentation of the object</returns>
        public override string ToString()
        {
            StringBuilder sb = new StringBuilder();
            sb.Append("class MetadataTreeForUpdateDto {\n");
            sb.Append("  Path: ").Append(Path).Append("\n");
            sb.Append("  Definition: ").Append(Definition).Append("\n");
            sb.Append("}\n");
            return sb.ToString();
        }

        /// <summary>
        /// Returns the JSON string presentation of the object
        /// </summary>
        /// <returns>JSON string presentation of the object</returns>
        public virtual string ToJson()
        {
            return Newtonsoft.Json.JsonConvert.SerializeObject(this, Newtonsoft.Json.Formatting.Indented);
        }

        /// <summary>
        /// To validate all properties of the instance
        /// </summary>
        /// <param name="validationContext">Validation context</param>
        /// <returns>Validation Result</returns>
        IEnumerable<ValidationResult> IValidatableObject.Validate(ValidationContext validationContext)
        {
            // Path (string) minLength
            if (this.Path != null && this.Path.Length < 1)
            {
                yield return new ValidationResult("Invalid value for Path, length must be greater than 1.", new [] { "Path" });
            }

            yield break;
        }
    }

}
